BEGIN {
    getline;
    n[1]=$1; n[2]=$2; n[3]=$3; zoom=$4;
    getline;
    if ($4 == "") {
	a[1,1]=$1*zoom; a[2,1]=$2*zoom; a[3,1]=$3*zoom;
	getline;
	a[1,2]=$1*zoom; a[2,2]=$2*zoom; a[3,2]=$3*zoom;
	getline;
	a[1,3]=$1*zoom; a[2,3]=$2*zoom; a[3,3]=$3*zoom;
    } else {
	print "str2xyz cannot interpret format 'a b c alpha beta gamma'" > "/dev/stderr";
	a[1,1]=$1; a[2,1]=0;  a[3,1]=0;
	getline;
	a[1,2]=0;  a[2,2]=$2; a[3,2]=0;
        getline;
        a[1,3]=0;  a[2,3]= 0; a[3,3]=$3;
    }
    for (i=1; i<=3; i++) {
	getline;
	c[1,i]=$1; c[2,i]=$2; c[3,i]=$3;
    }
    for (i=1; i<=3; i++) {
	for (j=1; j<=3; j++) {
	    ac[i,j]=0;
	    for (k=1; k<=3; k++) {
		ac[i,j]+=a[i,k]*c[k,j];
	    }
	}
    }
    nb=0;
}

{
    nb++;
    x[1]=$1; x[2]=$2; x[3]=$3; at[nb]=$4;
    for (i=1; i<=3; i++) {
	ax[i,nb]=0.;
	for (j=1; j<=3; j++) {
	    ax[i,nb]+=a[i,j]*x[j];
	}
    }
}

END {
    print nb*n[1]*n[2]*n[3];
    print "Title";
    for (w[1]=0; w[1]<n[1]; w[1]++) {
	for (w[2]=0; w[2]<n[2]; w[2]++) {
	    for (w[3]=0; w[3]<n[3]; w[3]++) {
		for (j=1; j<=3; j++) {
		    lat[j]=0.;
		    for (k=1; k<=3; k++) {
			lat[j]+=ac[j,k]*w[k];
		    }
		}
		for (i=1; i<=nb; i++) {
		    print at[i],ax[1,i]+lat[1],ax[2,i]+lat[2],ax[3,i]+lat[3];
		}
	    }
	}
    }
}
